/*
 * Grille2D.h
 *
 *  Created on: 13 nov. 2009
 *      Author: Anya
 */

#ifndef GRILLE2D_H_
#define GRILLE2D_H_

#include<vector.h>
#include <math.h>
#include "Grille1D.h"

/*
 * Comme en C, le fichier d'entte sert  faire toutes les dclarations;
 * elles sont encapsules dans celle de la classe
 * On dcrit ici les prototypes des mthodes de la classe
 * et les atributs
 *
 * Remarque. Pensez  crire les mthodes d'accs  aux attribus privs!
 */
class Grille2D {
public:

	Grille2D();
	Grille2D(double, double, double, double, double, double);
	Grille2D(double, double, int, double, double, int);

	double getBornInfX();
	double getBornSupX();

	double getBornInfY();
	double getBornSupY();

	vector<double> getPoints();
	int getNbPointsX();
	int getNbPointsY();

	virtual ~Grille2D();

private:
        Grille1D *GrilleX;
        Grille1D *GrilleY;
};
#endif /* GRILLE2D_H_ */
