/*
 * MatriceTriDiagonale.h
 *
 *  Created on: 8 dc. 2009
 *      Author: Anya
 */

#ifndef MATRICETRIDIAGONALE_H_
#define MATRICETRIDIAGONALE_H_

#include<valarray>
#include<vector.h>
#include "Except_matrice.h"
using namespace std;


class MatriceTriDiagonale {
public:
	MatriceTriDiagonale();// constructeur par dfaut
	//constructeur  partir de la donnes de la dimension
		MatriceTriDiagonale(int );
	//constructeur  partir de la donnes des diaginales
	MatriceTriDiagonale(int ,valarray<double>, valarray<double>, valarray<double>);
	//constructeur  partir d'une mtrice pleine
	MatriceTriDiagonale(  vector <vector<double> > M);

	void afficher();
	// Oprateur de somme de dux matrices
	MatriceTriDiagonale operator +(MatriceTriDiagonale A);

	// Oprateur de somme de dux matrices
		valarray<double> operator *(valarray<double> x);
	//oprateur d'accs en lecteur /criture aux lments des trois diagonales
	double & operator ()(int i,int j);
	//oprateur d'accs  une ligne de la matrice
	valarray<double>  operator [](int i);
	// algorithme de Thomas
	void   Thomas(valarray<double> y, valarray<double> *x);

	valarray<double> getDiagCentral();
	valarray<double> getDiagL();
	valarray<double> getDiagU();
	int getDim();



	 //destructeur
	virtual ~MatriceTriDiagonale();

private:

	int dim;//la dimension de la matrice
	valarray<double> diagCentral;// la diagonale centrale
	valarray<double> diagL;//la diagonale sous la centrale
	valarray<double> diagU;// la diagonale au-dessus de la centrale
};

#endif /* MATRICETRIDIAGONALE_H_ */
